> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/networking/sdn/data-center-port/describeportusablevlan.md).

# DescribePortUsableVlan

## 1. API Description

This API (DescribePortUsableVlan) is used to query Port Available VLAN

{% hint style="info" %}
**Notes**

* Either the port or the data center must be provided.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description                                                                                                                                                                           |
| -------------- | -------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| portId         | No       | String | <p>Port ID.</p><p>Either the port or the data center must be provided.</p>                                                                                                            |
| dcId           | No       | String | <p>Data center four-letter code. Obtainable via the <a href="/pages/6NryHUpaL9ykwvihast7">DescribeDataCenters</a> API.</p><p>Either the port or the data center must be provided.</p> |

## 3. Output Parameters

| Parameter Name | Type             | Description                                                                                                           |
| -------------- | ---------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String           | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| start          | Integer          | Start value of the VLAN range.                                                                                        |
| end            | Integer          | End value of the VLAN range.                                                                                          |
| inuseVlanList  | Array of Integer | List of VLANs currently in use.                                                                                       |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}

```json
POST /api/v2/sdn HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribePortUsableVlan
<Common Request Params>

Request: {
  "portId": "your-port-id"
}

Response: {
  "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
  "response": {
    "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
    "start": 1,
    "end": 4000,
    "inuseVlanList":[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 3999, 4000]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                    | Description                                      |
| ---------------- | ----------------------------- | ------------------------------------------------ |
| 400              | INVALID\_PORT\_OR\_DATACENTER | At least one of portId or dcId must be provided. |
